<template>
  <div v-if="loaded" style="display: flex; flex-direction: column; min-height: 100vh;">
    <header>
      <v-layout>
        <v-app-bar color="#fcc200">
          <v-app-bar-nav-icon @click.stop="toggleDrawer"></v-app-bar-nav-icon>

          <v-app-bar-title class="text-center font-bold">
            ระบบยืม-คืนอุปกรณ์
            <p style="font-size: small">
              มหาวิทยาลัยเทคโนโลยีราชมงคลอีสาน วิทยาเขตขอนแก่น
            </p>
          </v-app-bar-title>

          <v-menu min-width="300px" rounded>
            <template v-slot:activator="{ props }">
              <v-btn icon v-bind="props">
                <v-avatar color="white" size="large">
                  <img v-if="media && imgPath" :src="media + imgPath" class="picturelayout" alt="ImageMe" />
                  <img v-else class="picturelayout-else" src="/assets/image/profile.png" alt="Profile Image" />
                </v-avatar>
              </v-btn>
            </template>

            <v-card rounded="lg">
              <v-card-text>
                <div class="mx-auto text-center">
                  <div color="white" style="
                    padding: 5px;
                    border-radius: 10px;
                    box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.1);
                  ">
                    <v-row no-gutters>
                      <v-avatar color="white" size="large">
                        <img v-if="media && imgPath" :src="media + imgPath" class="picturelayout" alt="ImageMe" />
                        <img v-else class="picturelayout-else" src="/assets/image/profile.png" alt="Profile Image" />
                      </v-avatar>
                      <p style="margin: 15px; font-size: 18px; font-weight: bold" v-if="userData">
                        {{ userData.firstname }} {{ userData.lastname }}
                      </p>
                    </v-row>
                  </div>

                  <v-divider class="my-1"></v-divider>
                  <v-btn @click="onDatame" block variant="text" rounded="lg">
                    <p style="font-size: 18px">ข้อมูลส่วนตัว</p>
                  </v-btn>
                  <v-divider class="my-1"></v-divider>
                  <v-btn @click="onLogout" block color="#E58900" rounded="lg" prepend-icon="mdi-logout">
                    <template v-slot:prepend>
                      <v-icon color="black"></v-icon>
                    </template>
                    <p style="font-size: 18px; font-weight: bold" class="text-black">
                      ออกจากระบบ
                    </p>
                  </v-btn>
                </div>
              </v-card-text>
            </v-card>
          </v-menu>
        </v-app-bar>
      </v-layout>
    </header>

    <v-sheet>
      <v-layout>
        <v-navigation-drawer v-model="drawer" location="left" temporary>
          <div class="menu">
            <v-btn variant="text" icon="mdi-close" @click.stop="drawer = !drawer"></v-btn>
            <nuxt-link to="/" class="link">
              <v-btn :ripple="{ class: 'text-amber' }" block variant="text">
                <p>หน้าแรก</p>
              </v-btn>
            </nuxt-link>
            <v-btn @click.stop="toggleDrawerBasket" :ripple="{ class: 'text-amber' }" block variant="text" class="link">
              <v-badge v-if="basket.length > 0" :content="basket.length" inline>
                <p>ตะกร้าอุปกรณ์</p>
              </v-badge>
              <p v-else>ตะกร้าอุปกรณ์</p>
            </v-btn>
            <nuxt-link to="/borrowing-and-return" class="link">
              <v-btn :ripple="{ class: 'text-amber' }" block variant="text">
                <p>รายการยืม-คืน</p>
              </v-btn>
            </nuxt-link>
            <v-btn @click.stop="toggleDrawerNoti" :ripple="{ class: 'text-amber' }" block variant="text" class="link">
              <v-badge v-if="readedNotificationsCount > 0" :content="readedNotificationsCount" inline>
                <p>การแจ้งเตือน</p>
              </v-badge>
              <p v-else>การแจ้งเตือน</p>
            </v-btn>
            <nuxt-link to="/help" class="link">
              <v-btn :ripple="{ class: 'text-amber' }" block variant="text">
                <p>ศูนย์ช่วยเหลือ</p>
              </v-btn>
            </nuxt-link>
            <nuxt-link v-if="requestsManagement" to="/requests-management" class="link">
              <v-btn :disabled="!requestsManagement" :ripple="{ class: 'text-amber' }" block variant="text">
                <p>จัดการรายการ</p>
              </v-btn>
            </nuxt-link>
            <nuxt-link v-if="itemsManagement" to="/items-management" class="link">
              <v-btn :disabled="!itemsManagement" :ripple="{ class: 'text-amber' }" block variant="text">
                <p>จัดการอุปกรณ์</p>
              </v-btn>
            </nuxt-link>
          </div>
        </v-navigation-drawer>
      </v-layout>
    </v-sheet>

    <v-sheet>
      <v-layout>
        <v-navigation-drawer v-model="drawerNoti" location="left" temporary max-width="100%" width="350"
          color="#ececec">
          <v-btn variant="text" icon="mdi-close" @click.stop="toggleDrawerNoti"></v-btn>
          <p class="title">การแจ้งเตือน</p>

          <v-infinite-scroll mode="manual" height="auto">
            <template v-for="(notification) in notifications" :key="notification">
              <v-card @click="onRead(notification.id, notification.readed)" class="card-noti d-flex justify-center"
                :color="notification.readed ? '#ececec' : '#ffff'">
                <div class="description">
                  <div class="noti-title">{{ notification.title }}</div>
                  <p>รายการ : {{ notification.request.id }}</p>
                  <p>อุปกรณ์ : {{ notification.request.equipment.name }}</p>
                  <p>{{ notification.description }}</p>
                  <div class="text-center time-stamp">{{ formatDateTime(notification.createdAt) }}</div>
                </div>

                <div class="ml-auto">
                  <v-btn @click="onDeleteNotification(notification.id)" variant="text" icon="mdi-close"></v-btn>
                </div>
              </v-card>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-navigation-drawer>
      </v-layout>
    </v-sheet>

    <v-sheet>
      <v-layout>
        <v-navigation-drawer v-model="drawerBasket" location="left" temporary max-width="100%" width="350"
          color="#ececec">
          <v-btn variant="text" icon="mdi-close" @click.stop="toggleDrawerBasket"></v-btn>
          <p class="title">ตะกร้าอุปกรณ์</p>

          <v-infinite-scroll mode="manual" height="100%">
            <template v-for="(basket) in basket" :key="basket">
              <nuxt-link :to="'/borrowing-confirmation/' + basket.id" class="link">
                <v-card class="card-noti d-flex justify-center">
                  <div class="d-flex align-center">
                    <v-img v-if="basket.image && basket.image.length > 0" :src="media + basket.image[0].url" :aspect-ratio="1" class="img" width="65" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" class="img" width="65" cover />
                  </div>

                  <div class="description">
                    <div class="eq-name">{{ basket.name }}</div>
                    <div class="d-flex">
                      <p class="des-layout">ระยะเวลาในการยืม</p>
                      <p>{{ basket.day_limit }} วัน</p>
                    </div>
                    <div class="d-flex">
                      <p class="des-layout">จำนวนคงเหลือ</p>
                      <p>{{ basket.quantity }}</p>
                    </div>
                    <p>{{ basket.provider_name }}</p>
                  </div>

                  <div class="ml-auto">
                    <v-btn @click.stop.prevent="onDeleteEquipment(basket.id)" variant="text" icon="mdi-close"></v-btn>
                  </div>
                </v-card>
              </nuxt-link>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-navigation-drawer>
      </v-layout>
    </v-sheet>

    <v-sheet width="100%" max-width="1000" class="mx-auto" color="#ececec" style="margin-top: 70px">
      <v-layout>
        <v-main>
          <slot />
        </v-main>
      </v-layout>
    </v-sheet>

    <footer class="mt-auto">
      <v-layout>
        <v-footer color="#fcc200" class="mt-auto">
          <v-row justify="center" no-gutters>
            <v-col class="text-center" cols="12">
              ©2023 — 2024 | มหาวิทยาลัยเทคโนโลยีราชมงคลอีสาน วิทยาเขตขอนแก่น
            </v-col>
          </v-row>
        </v-footer>
      </v-layout>
    </footer>
  </div>
</template>

<script setup>
const { logout } = useStrapiAuth();
const router = useRouter();
import { ref, onMounted, onBeforeUnmount } from "vue";
import axios from "axios";

const url = useStrapiUrl()
const token = useStrapiToken()
const userData = ref()
const imgPath = ref("")
const media = useStrapiMedia()

const itemsManagement = ref(false)
const requestsManagement = ref(false)

const drawer = ref(false)
const drawerNoti = ref(false)
const drawerBasket = ref(false)

const notifications = ref([])
const basket = ref()
const loaded = ref(false)

const toggleDrawer = async () => {
  drawer.value = !drawer.value;
  await getBasket();
  await getNotification();
};

const toggleDrawerNoti = async () => {
  drawerNoti.value = !drawerNoti.value;
  await getNotification();
};

const toggleDrawerBasket = async () => {
  drawerBasket.value = !drawerBasket.value;
};

async function getBasket() {
  try {
    await axios.get(`${url}/users/me`, {
      params: {
        fields: {
          0: 'id',
        },
        populate: {
          basket: {
            fields: {
              1: 'id',
              2: 'name',
              3: 'quantity',
              4: 'day_limit',
              5: 'provider_name',
            },
            populate: {
              image: {
                fields: {
                  6: 'url',
                }
              }
            }
          }
        },
      },
      headers: {
        Authorization: `Bearer ${token.value}`,
      },
    }).then((response) => {
      if (response.data.basket) {
        basket.value = response.data.basket.reverse();
      } else {
        basket.value = [];
      }
    });
  } catch (error) {
    console.log(error);
  }
}

async function onDeleteEquipment(equipmentId) {
  try {
    const user = await useStrapiUser()
    await axios.put(`${url}/users/${user.value.id}`, {
      basket: {
        disconnect: [equipmentId]
      }
    }, {
      headers: {
        Authorization: `Bearer ${token.value}`,
      }
    })
    getBasket();

  } catch (error) {
    console.log(error)
  }
}

async function getNotification() {
  try {
    await axios.get(`${url}/users/me`, {
      params: {
        fields: {
          0: 'id'
        },
        populate: {
          notifications: {
            fields: {
              1: 'title',
              2: 'description',
              3: 'createdAt',
              4: 'readed',
            },
            populate: {
              request: {
                fields: {
                  5: 'id',
                },
                populate: {
                  equipment: {
                    fields: {
                      6: 'name',
                    }
                  }
                }
              }
            }
          }
        }
      },
      headers: {
        Authorization: `Bearer ${token.value}`,
      },
    }).then((response) => {
      if (response.data.notifications) {
        notifications.value = response.data.notifications.reverse();
      } else if (!response.data.notifications) {
        notifications.value = [];
      }
    })

  } catch (error) {
    console.log(error)
  }
}

async function onDeleteNotification(notiId) {
  try {
    await axios.delete(`${url}/notifications/${notiId}`, {
      headers: {
        Authorization: `Bearer ${token.value}`,
      },
    })
    getNotification();
    
  } catch (error) {
    console.log(error)
  }
}

async function onRead(readId, readed) {
  if (readed == false) {
    try {
      await axios.put(`${url}/notifications/${readId}`, {
        data: {
          readed: true
        },
      }, {
        headers: {
          Authorization: `Bearer ${token.value}`,
        },
      })
      getNotification();
  
    } catch (error) {
      console.log(error)
    }
  }
}

const formatDateTime = (timestamp) => {
  const utcDateTime = new Date(timestamp);
  const bangkokDate = utcDateTime.toLocaleString("th-TH", { timeZone: "Asia/Bangkok" });
  return bangkokDate;
};

const readedNotificationsCount = computed(() => {
  return notifications.value.filter(notification => !notification.readed).length;
});

onMounted(async () => {
  const response = await axios.get(`${url}/users/me`, {
    params: {
      fields: {
        1: 'prefix',
        2: 'firstname',
        3: 'lastname',
      },
      populate: {
        image: {
          fields: {
            4: "url",
          },
        },
        role: {
          fields: {
            5: "name"
          }
        }
      },
    },
    headers: {
      Authorization: `Bearer ${token.value}`,
    },
  });
  userData.value = response.data;

  if (response.data.image) {
    imgPath.value = response.data.image.url;
  }

  if (response.data.role.name === "Admin") {
    itemsManagement.value = true
    requestsManagement.value = true
  }

  await getNotification();
  await getBasket();

  loaded.value = true
});

const onLogout = () => {
  logout();
  router.push("/login");
};

const onDatame = () => {
  router.push("/userdetail");
};
</script>

<style scoped>
@import url(../assets/css/styles/layout.css);
</style>
